/*
  Copyright (C) 2009 Pot Etienne

  This file is part of Vocab++.

  Vocab++ is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Vocab++ is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Vocab++.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "clavier_virtuel.hpp"

Clavier_virtuel::Clavier_virtuel(QString c_nom, QString c_touches_clavier, QWidget *parent, Qt::WindowFlags f) : QWidget(parent, f)
{
    nom = c_nom;
    touches_clavier = c_touches_clavier;

    QVBoxLayout* layout_clavier = new QVBoxLayout;
    QList<QHBoxLayout*> ligne_clavier;

    ligne_clavier.append(new QHBoxLayout());
    ligne_clavier.last()->addStretch();
    for(int i = 0 ; i < touches_clavier.size() ; ++i)
    {
        if(touches_clavier.at(i) == '\n')
        {
            if(touches_clavier.at(i-1) == '\n')
            {
                layout_clavier->addSpacing(10);
            }
            ligne_clavier.last()->addStretch();
            layout_clavier->addLayout(ligne_clavier.last());
            ligne_clavier.append(new QHBoxLayout());
            ligne_clavier.last()->addStretch();
        }
        else if(touches_clavier.at(i) == ' ')
        {
            ligne_clavier.last()->addSpacing(30);
        }
        else
        {
            QPushButton *touche = new QPushButton(touches_clavier.at(i));
            connect(touche, SIGNAL(clicked()), &mapper_clavier_virtuel, SLOT(map()));
            mapper_clavier_virtuel.setMapping(touche, touche->text());
            ligne_clavier.last()->addWidget(touche);
        }
    }
    ligne_clavier.last()->addStretch();
    layout_clavier->addLayout(ligne_clavier.last());

    setLayout(layout_clavier);

    connect(&mapper_clavier_virtuel, SIGNAL(mapped(const QString &)), this, SIGNAL(touche_appuyee(QString)));
}

void Clavier_virtuel::closeEvent(QCloseEvent *event)
{
    emit clavier_ferme(false);
    event->accept();
}

QString Clavier_virtuel::get_nom() const
{
    return nom;
}

QString Clavier_virtuel::get_touches_clavier() const
{
    return touches_clavier;
}
