/*
  Copyright (C) 2009 Pot Etienne

  This file is part of Vocab++.

  Vocab++ is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Vocab++ is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Vocab++.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef CLAVIER_VIRTUEL_HPP
#define CLAVIER_VIRTUEL_HPP

#include <QtGui>

class Clavier_virtuel : public QWidget
{
    Q_OBJECT

public:
    Clavier_virtuel(QString nom, QString touches_clavier, QWidget *parent = 0, Qt::WindowFlags f = 0);
    void closeEvent(QCloseEvent *event);

    QString get_nom() const;
    QString get_touches_clavier() const;

signals:
    void touche_appuyee(QString);
    void clavier_ferme(bool);

private:
    QSignalMapper mapper_clavier_virtuel;
    QString nom;
    QString touches_clavier;
};

#endif
