/*
  Copyright (C) 2009 Pot Etienne

  This file is part of Vocab++.

  Vocab++ is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Vocab++ is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Vocab++.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef DIALOG_AJOUTER_QUESTION_HPP
#define DIALOG_AJOUTER_QUESTION_HPP

#include <QtGui>
#include <iostream>

#include "question.hpp"
#include "valeurs_par_defaut.hpp"
#include "widget_tags.hpp"
#include "clavier_virtuel.hpp"

class Dialog_ajouter_question : public QDialog
{
    Q_OBJECT

public:
    Dialog_ajouter_question(QStringList *c_liste_tags, QStringList *c_liste_tags_defaut, QList<QDockWidget*> *c_claviers_virtuels, QWidget *parent = 0);
    static QString calculer_regexp(QString pattern);

public slots:
    int exec(Question *c_question_a_ajouter);

protected:
    bool eventFilter(QObject *object, QEvent *event);

private slots:
    void question_regexp_calculer();
    void reponse_regexp_calculer();
    void difficulte_par_defaut();
    void tags_par_defaut();
    void ajouter_tags_par_defaut();
    void liste_tags_afficher();

    void question_reinitialiser();
    void reponse_reinitialiser();
    void question_regexp_reinitialiser();
    void reponse_regexp_reinitialiser();
    void difficulte_reinitialiser();
    void tags_reinitialiser();

    void plus_d_option_afficher(bool);
    void valider();
    void reinitialiser();

    void modifie();
    void modifie_question();
    void modifie_reponse();
    void modifie_question_regexp();
    void modifie_reponse_regexp();
    void modifie_difficulte();
    void modifie_tags();

    void ajouter_caractere_special(QString caractere);

private:
    Question *question_a_ajouter;
    QStringList *liste_tags;
    QStringList *liste_tags_defaut;
    QObject *dernier_champ_a_avoir_le_focus;

    QLineEdit *champ_question;
    QPushButton *bouton_question_reinitialiser;
    QLineEdit *champ_reponse;
    QPushButton *bouton_reponse_reinitialiser;
    QWidget *cadre_option;
    QLineEdit *champ_question_regexp;
    QPushButton *bouton_question_regexp_calculer;
    QPushButton *bouton_question_regexp_reinitialiser;
    QLineEdit *champ_reponse_regexp;
    QPushButton *bouton_reponse_regexp_calculer;
    QPushButton *bouton_reponse_regexp_reinitialiser;
    QComboBox *liste_deroulante_difficulte;
    QPushButton *bouton_difficulte_par_defaut;
    QPushButton *bouton_difficulte_reinitialiser;
    Widget_tags *widget_tags;
    QPushButton *bouton_tags_par_defaut;
    QPushButton *bouton_ajouter_tags_par_defaut;
    QPushButton *bouton_tags_reinitialiser;

    QPushButton *bouton_plus_d_option;
    QPushButton *bouton_valider;
    QPushButton *bouton_annuler;
    QPushButton *bouton_reinitialiser;//efface tous les champs
    QPushButton *bouton_claviers_virtuels;//efface tous les champs

    QList<Clavier_virtuel*> claviers_virtuels;
};

#endif
