/*
  Copyright (C) 2009 Pot Etienne

  This file is part of Vocab++.

  Vocab++ is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Vocab++ is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Vocab++.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef DIALOG_GERER_CLAVIERS_VIRTUELS_HPP
#define DIALOG_GERER_CLAVIERS_VIRTUELS_HPP

#include <QtGui>
#include <iostream>

#include "clavier_virtuel.hpp"

class Contenu_clavier
{
    public:
    Contenu_clavier() : modifier(false), supprimer(false) {}

    QString nom;
    QString touches;

    bool modifier;
    bool supprimer;
};

class Widget_edition_clavier_virtuel : public QWidget
{
    public:
    Widget_edition_clavier_virtuel(Contenu_clavier *c_contenu) : contenu(c_contenu)
    {
        text_nom = new QLabel(contenu->nom);
        bouton_modifer = new QPushButton(trUtf8("Modifier"));
        bouton_supprimer = new QPushButton(trUtf8("Supprimer"));

        QHBoxLayout *layout_principal = new QHBoxLayout;
        layout_principal->addWidget(text_nom);
        layout_principal->addStretch();
        layout_principal->addWidget(bouton_modifer);
        layout_principal->addWidget(bouton_supprimer);

        setLayout(layout_principal);
    }

    QLabel *text_nom;
    QPushButton *bouton_modifer;
    QPushButton *bouton_supprimer;
    Contenu_clavier *contenu;// pour savoir à quoi correspond la ligne
};

class Dialog_gerer_claviers_virtuels : public QDialog
{
    Q_OBJECT

public:
    Dialog_gerer_claviers_virtuels(QList<QDockWidget*> *c_claviers_virtuels, QWidget *parent = 0);

private slots:
    void modifier_clavier(QWidget *widget);
    void supprimer_clavier(QWidget *widget);
    void nouveau_clavier();

    void valider_modification();
    void reinitialiser_modification();

    void defaut();
    void reinitialiser();
    void valider();

private:
    QList<Contenu_clavier*> claviers_virtuels;
    Contenu_clavier *clavier_actuel;
    QList<QDockWidget*> *docks_claviers_virtuels;

    QSignalMapper *mapper_modifier;
    QSignalMapper *mapper_supprimer;

    QFrame *cadre_liste;
    QLabel *texte_liste;
    QScrollArea *aire_liste_claviers;
    QWidget *widget_liste_claviers;
    QList<Widget_edition_clavier_virtuel*> ligne_clavier_virtuel;
    QVBoxLayout *layout_liste_claviers_virtuels;
    QPushButton *bouton_ajouter;

    QFrame *cadre_edition;
    QLineEdit *champ_nom;
    QTextEdit *champ_touche;
    QPushButton *bouton_reinitialiser_champs;
    QPushButton *bouton_modifier;

    QPushButton *bouton_defaut;
    QPushButton *bouton_reinitialiser;
    QPushButton *bouton_valider;
    QPushButton *bouton_annuler;
};

#endif
