/*
  Copyright (C) 2009 Pot Etienne

  This file is part of Vocab++.

  Vocab++ is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Vocab++ is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Vocab++.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef DIALOG_GERER_TAGS_H
#define DIALOG_GERER_TAGS_H

#include <QtGui>
#include <iostream>

#include "widget_tags.hpp"

class Tag_modifie
{
public:
    Tag_modifie(QString c_ancien_tag, QString c_nouveau_tag) : ancien_tag(c_ancien_tag), nouveau_tag(c_nouveau_tag) {}

    QString ancien_tag;//est vide si le tag n'existait pas
    QString nouveau_tag;//est vide si le tag à été supprimé
};

// TODO : Optimisations pour la liste des tags modifiés(une seule fois chaque tag)
class Dialog_gerer_tags : public QDialog
{
    Q_OBJECT

public:
    Dialog_gerer_tags(QStringList *c_liste_tags, QList<Tag_modifie> *c_modifications_tag, QWidget *parent = 0);

private slots:
    void ligne_editee(QStandardItem *item);

    void ajouter();
    void supprimer();
    void reinitialiser();
    void defaire();
    void refaire();

protected:
    void keyReleaseEvent(QKeyEvent *event);

private:
    QStringList *liste_tags;
    QList<Tag_modifie> *modifications_tag;
    QStandardItemModel *model_liste_tags;

    QFrame *cadre_liste_tags;
    QLabel *texte_liste_tags;
    QListView *vue_liste_tags;
    QPushButton *bouton_ajouter;
    QPushButton *bouton_supprimer;

    QPushButton *bouton_reinitialiser;
    QPushButton *bouton_defaire;
    QPushButton *bouton_refaire;
    QPushButton *bouton_valider;
    QPushButton *bouton_annuler;
};

#endif // DIALOG_GERER_TAGS_H
