/*
  Copyright (C) 2009 Pot Etienne

  This file is part of Vocab++.

  Vocab++ is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Vocab++ is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Vocab++.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef DIALOG_REINITIALISER_HPP
#define DIALOG_REINITIALISER_HPP

#include <QtGui>
#include <iostream>

#include "question.hpp"
#include "valeurs_par_defaut.hpp"

class Dialog_reinitialiser : public QDialog
{
    Q_OBJECT

public:
    Dialog_reinitialiser(QList<Question*> *c_liste_questions, QList<Question*> *c_liste_questions_filtrees, QWidget *parent = 0);
    static bool reinitialiser(QList<Question*> *liste_questions,
                              QList<Question*> *liste_questions_filtrees,
                              bool liste_questions_filtrees_reinitialise,
                              bool score_reinitialise,
                              bool score_maximum_reinitialise,
                              bool date_derniere_fois_posee_reinitialise,
                              bool nombre_de_fois_posee_reinitialise,
                              bool nombre_de_fois_reussi_reinitialise,
                              bool date_ajout_reinitialise,
                              bool difficulte_reinitialise,
                              bool tags_reinitialise);

public slots:
    bool exec();

private slots:
    void actualiser_bouton_tout_cocher(bool checked);
    void bouton_tout_cocher_clique(bool checked);

private:
    QSettings settings;
    QList<Question*> *liste_questions;
    QList<Question*> *liste_questions_filtrees;

    QCheckBox *check_box_liste_questions_filtrees_reinitialise;

    QCheckBox *check_box_score_reinitialise;
    QCheckBox *check_box_score_maximum_reinitialise;
    QCheckBox *check_box_date_derniere_fois_posee_reinitialise;
    QCheckBox *check_box_nombre_de_fois_posee_reinitialise;
    QCheckBox *check_box_nombre_de_fois_reussi_reinitialise;
    QCheckBox *check_box_date_ajout;
    QCheckBox *check_box_difficulte_reinitialise;
    QCheckBox *check_box_tags_reinitialise;

    QPushButton *bouton_tout_cocher;
    QPushButton *bouton_valider;
    QPushButton *bouton_annuler;
};

#endif
