/*
  Copyright (C) 2009 Pot Etienne

  This file is part of Vocab++.

  Vocab++ is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Vocab++ is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Vocab++.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef DIALOG_TRIER_HPP
#define DIALOG_TRIER_HPP

#include <QtGui>

#include "question.hpp"


enum type_de_tris
{
    TRIS_QUESTION = 0,
    TRIS_REPONSE = 1,
    TRIS_DATE_AJOUT = 2,
    TRIS_DATE_DERNIERE_FOIS_POSEE = 3,
    TRIS_SCORE = 4,
    TRIS_SCORE_MAXIMUM = 5,
    TRIS_NOMBRE_DE_FOIS_POSEE = 6,
    TRIS_NOMBRE_DE_FOIS_REUSSI = 7,
    TRIS_DIFFICULTEE = 8
};

class Dialog_trier : public QDialog
{
    Q_OBJECT

public:
    Dialog_trier(QList<Question*> *c_liste_questions, QWidget *parent = 0);

private slots:
    void trier();

private:
    QList<Question*> *liste_questions;

    QLabel *texte_mode_de_tris;
    QComboBox *liste_deroulante_mode_de_tris;
    QLabel *texte_croissant_decroissant;
    QComboBox *liste_deroulante_croissant_decroissant;
    QSlider *slider_hasard;
    QSpinBox *texte_hasard_valeur;
    QLabel *texte_hasard;

    QPushButton *bouton_trier;
    QPushButton *bouton_annuler;
};

#endif
