/*
  Copyright (C) 2009 Pot Etienne

  This file is part of Vocab++.

  Vocab++ is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Vocab++ is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Vocab++.  If not, see <http://www.gnu.org/licenses/>.
*/

/*
    DONE :
    - ameliorations des doublons:
        - DONE : detections des doublons(dans "ajouter une question)
        - DONE : option "oui pour tous" et non pour tous dans la boite de dialogue
    - Bugs
        - DONE : Création d'une fonction : reposer la question à l'identique qui si la première question n'a pas été modifiée, repose Q->R ou R->Q comme le coup d'avant
        - DONE : Pour les questions inversé
        - DONE : si on supprime une question selectionner filtrée, ca bug(ne change pas de couleur et ne la supprime pas)
        - DONE : verification des doublons dans liste filtrée
        - DONE : ne pas modifier la liste au chargement si toutes les questions ont été filtrées
        - DONE : Quand on enleve le filtre : les questions restent en bleu
        - DONE : Quand on modifie une question : Attention de bien actualisé les regex si l'utilisateur ne l'a pas fait
        - DONE ? : quelques bug pour le dossier d'ouverture par defaut
    - Clavier virtuel
        - DONE : taille maximum des docks
    - menus du tableau :
        - DONE : vertical : inverser les chiffre
        - DONE : quand on clique sur un menu vertical, ca selectionne la ligne
    - options de configurations
        - DONE : au démarage, démarer sur une liste personalisée
    - gramaire :
        - DONE gestion du pluriel : quand une seule question est séléctionée, afficher "supprimer/modifier la question séléctionée"
    - interface :
        - DONE : réinplémenter les boutons opérations dans le widget central(avec options pour les cacher)
        - DONE : bouton supprimer question à coté du bouton skip (">>") -> possibilité de cacher ces 2 boutons ainsi que le bouton "effacer"
        - DONE : titre change si la liste est modifiée(avec tag et nom du fichier : ex "[modifié]listeAll->Fr - Vocab++")
    - messages de confirmations :
        - DONE : compléter boites de dialogues "réinitialiser" : choix par default(enregisté dans les settings), dernier choix utilisé ?, case tout cocher/tout décocher
    BUG :
    - Quand on appuie sur Suppr, les question ce suppriment(c'est ce qu'il faut) mais la case du tableau se vide(A RÉCTIFIER!!!)
    TODO :
    - interne :
        - creer des fonctions si des morceaux de codes sont duppliqués
        - si ce n'est pas possible, creer des macros
        - déplacer dans private certains slots de private slots (car ils ne sont pas utilisé comme tels)
        - renomer quelques variables(tolérance accents,...) ? ? ? ? ? ? ? ? ? ? ? ? ?
        - vérification que trUtf8 est bien partout
        - verifier la gestion de la mémoire
        - deplacer certaines class dans le cpp ? car on ne doit pas pouvoir les utiliser en dehors
        - rajouter le mot-clef const et utiliser des references ou des pointeurs pour optimiser la vitesse au passage de liste en parametre
        - encapsulation parfois mal respecté(uniquement pour les class-structures)
        - read_settings et write_settings
        - remplacer selectedIndexes par selectedRow ?
        - les modification des claviers ce fait dans main_window et non dans dialog_gerer_clavier_virtuels(comme l'ajout de question)
    - claviers virtuels
        - majuscule, alt et alt Gr pour clavier virtuel
        - BUG : si l'utilisateur supprime tous les claviers virtuels : on ce retrouve avec les claviers virtuels par defaut
        - ne creer clavier virtuel que quand on en a besoin
        - dock tous les carractères spéciaux, accessible dans la boite "ajouter un clavier virtuel"(sous forme de widget)
    - liste :
        - personalisation des collones visibles
        - quand on clique sur un menu horizontal, ca trie la colone séléctionnée(par ordre alphabetique) -> TABLEAU LISTE DES QUESTIONS UNIQUEMENT
    - systeme de filtre(par date, par score, par difficulté,...)->nouveau menu?
        - ...en gros memes options(et interface ?) que pour trier
    - possibilité(case à cocher) de calcul automatique de la difficulté en fonction du nombre de bonne réponse de nombre de X posée,...
    - pouvoir rajouter la liste à la fin ou au début(ou autre choix ?) lorsque l'on charge un fichier ou que l'on ajoute une question ou que des question ne sont plus filtrées
    - options de configurations
        - case à cocher : "au démarage reprendre les options de la dernière utilisation"
        - option pour enpecher le redimentionnement de la fenetre/du tableau/des colones
    - interface :
        - menu "affichage" ou l'on peut afficher/cacher les boutons oppérations, les barres d'outils,...
        - interdire le redimentionnement vertical de la fenetre de filtre
        - barres d'outils standard(nouveau, ouvrir, sauvegarder,...), de filtre, de Q->R/R->Q,...
        - texte par defaut en gris clair pour le champ regexp : "laissez vide pour un completion automatique", idem pour les tags -> POUR VOKAB++
        - menu recement ouvert
        - collones pour les tags dans le widget tag
    - pour les questions trop longues :
        - les metre plusieurs lignes(seulement quand la premiere ligne est pleine) ?
        - taille maximum pour la ligne
    - autre :
        - action inverser filtres
        - sous menu qui permet de choisir rapidement la formule utiliser pour le replacement de la question(+ parametrable dans les options)
        - arbre pour les tags(catégories)
        - caractères spéciaux pour les question("#",...)
        - l'utilisateur peut appuyer sur le bouton "Je me suis trompé" meme si la question précédente à été filtrée
    SUGESTION
    - ne plus voir cette question ne nous montre vaiment plus la question(mais la garde dans une liste à part)
    - messages de confirmations : pour les boites de dialogues supprimer question : indiquer les details des questions à supprimer
    - synonymes, oposées
    - chargement : n'actualiser le filtre que pour les questions que l'on rajoute et non les questions actueles
    - lorsue l'on pose une question : les lignes du tableau correspondantes ce masquent
    - fichiers question+regexp et données utilisateur sont séparés
    - graphiques qui montrent la progression
    - limiter la liste aux x premieres questions
    - valeur aléatoire pour les filtres ? ? ?
    - gestion du temps : montrent depuis combien de temps on répond au question, calcule le temps de réponse d'une question,...
    - messages de confirmations : case à cocher : "ne plus m'avertir"
    - ameliorations des doublons:boite de dialogue dans "charger liste" avec case à cocher et liste de toutes les questions
    NE SERA PAS IMPLÉMENTÉ:
    - gestion de plusieurs fichiers à la fois :
        - Quand on en ouvre plusieurs, on nous demande si on veut les fusionner en 1 fichier ou les garder séparé
        - On demande à l'utilisateur dans quels fichiers les questions doivent etres ajoutées
        - On demande à l'utilisateur quels fichiers doivent etre sauvegardés
        - Etc, etc...
    - tips au démarage("le saviez vous ?") -> INUTILE !!!
    - griser boutons quand la liste est vide -> INUTILE !!!
    - description(tooltips?) pour les claviers virtuels -> INUTILE
*/

#ifndef MAINWINDOW_HPP
#define MAINWINDOW_HPP

#include <QtGui>
#include <iostream>

#include "valeurs_par_defaut.hpp"
#include "question.hpp"
#include "dialog_ajouter_question.hpp"
#include "dialog_trier.hpp"
#include "dialog_reinitialiser.hpp"
#include "dialog_filtrer.hpp"
#include "dialog_gerer_claviers_virtuels.hpp"
#include "dialog_gerer_tags.hpp"
#include "widget_tags.hpp"
#include "clavier_virtuel.hpp"


#define SCORE_MAX 100
#define SCORE_COULEUR_RATE 0
#define SCORE_COULEUR_MAX 5

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

protected:
    void closeEvent(QCloseEvent *event);//fonction appellée lorsque l'on tente de fermer la fenetre
    void resizeEvent(QResizeEvent *event);//adjuste le tableau au momment ou l'on redimentionne la fenetre
    void keyReleaseEvent(QKeyEvent *event);//au momment ou l'on appuis sur une touche, on la traite(entrer, supprimer,...)

private slots:
    bool charger_liste(QString nom_fichier_chargement);//ajoute les question à la liste en cours
    bool sauvegarder_liste(QString nom_fichier_sauvegarde);

    void vider_liste_completement();//vide la liste sans demander de confirmation
    void actualiser(bool juste);//actualise le tableau(décale tous les résultat) et met à jour les scores et cie
    void actualiser_taille(bool taille_modifiee = false);//redimentionne le tableau
    void actualiser_filtre();//supprime et ajoute les questions à la liste principale
    bool question_filtree(Question *);//return true si la question doit etre filtrée
    void poser_nouvelle_question();//pose la première question dans la liste
    void reposer_question();// idem mais dans le meme ordre que la question précedente
    void calculer_taille_maximum();
    void question_editee(int, int);
    void valider();//se contente juste de regarder la réponse entrée par l'utilisateur et voit si elle concorde avec la solution
    void ajouter_carractere_special(QString carractere);
    void ajouter_supprimer_tags_questions_selectionnees();

    void modifier_liste(bool nouvelle_valeur);

    void je_sais();
    void je_ne_sais_pas();
    void je_me_suis_trompe();
    void ne_plus_voir_cette_question();
    void sauter_cette_question();

    void nouvelle_liste();//crée une nouvelle liste vide
    void ouvrir_liste();//ouvre une nouvelle liste qui s'ajoute ou remplace la liste actuelle
    bool enregistrer_liste();//Retourne true si il a enregistré avec succes sinon, retourne false
    bool enregistrer_liste_sous();//Retourne true si il a enregistré avec succes sinon, retourne false
    void imprimer();

    void ajouter_question();
    void supprimer_question_actuelle();
    void supprimer_questions_selectionnees();
    void modifier_question_actuelle();// si on veut changer la difficulté par exemple
    void modifier_questions_selectionnees();
    void ne_plus_voir_question_actuelle();
    void ne_plus_voir_questions_selectionnees();
    void sauter_question_actuelle();
    void inverser_reponse_derniere_question();
    void vider_liste();//supprime toutes les questions actuelles(en demandant confirmation)
    void melanger_liste();//ouvre une boite de dialogue ou l'on peut selectionner les option pour melanger ou trier la liste
    void melanger_liste_defaut();//mélange la liste avec les options par defaut
    void filtrer_liste();
    void inverser_filtre();
    void reinitialiser_score();
    void statistiques_bonnes_reponses();
    void liste_des_questions();

    void ordre(QAction*);
    void affichage_duree(QAction*);
    void affichage_duree_personnalise();
    void definir_tags_defaut();
    void ajouter_supprimer_tags(bool supprimer = false);
    void supprimer_question_avec_tags();
    void gerer_tags();
    void gerer_claviers_virtuels();
    void calcul_automatique_difficultee(bool);
    void actualiser_filtre_en_permanace(bool);
    void ajouter_a_la_fin(bool);
    void tolerance(bool);
    void tolerance_accents(bool);
    void tolerance_majuscules(bool);
    void preferences();

    void manuel();
    void aide_en_ligne();
    void rechercher_mise_a_jour();
    void a_propos();

private:
    void creer_widget_principal();
    void creer_docks();
    void creer_actions();
    void creer_menus();
    void creer_menu_contextuel();
    void creer_barres_outils();
    void creer_barre_etat();

    void read_settings();
    void write_settings();

    bool avertir_si_modifier();//Enregistre le document actuel si l'utilisateur le souhaite et retourne true si l'utilisateur a confirmé l'action sinon, retourne false
    void actualiser_header_verticals();
    void actualiser_titre();
    void ajouter_clavier_virtuel(QString nom, QString touches_clavier);

    // Variables internes
    QSettings settings;

    long largeur_ecran;

    bool liste_modifiee;//Si le document actuel a été modifié
    QString nom_fichier_actuel;//Adresse du fichier actuel. Est égal à "" si la liste est nouvelle et n'a pas encore été enregistrée
    QString nom_repertoire_actuel;
    bool repertoire_dynamique;

    long valeur_inversion;
    QDateTime valeur_duree;
    bool difficultee_calculee_automatiquement;
    bool questions_ajoutees_a_la_fin;
    bool tolerant;
    bool accents_facultatifs;
    bool majuscules_facultatives;
    bool affiche_uniquement_fautes;
    QSignalMapper mapper_clavier_virtuels;

    QList<Question*> liste_questions;//liste de toutes les questions chargées
    QVector<Question*> liste_questions_tableau;//uniquement les questions affichée sur le tableau(pointeur sur les question de liste_questions)
    QVector<bool> liste_questions_tableau_inverse;
    QVector<int> liste_questions_tableau_score;
    int derniere_question_score_avant;
    int derniere_question_score_maximum_avant;

    QStringList liste_tags;
    QStringList liste_tags_defaut;

    bool inverse;
    bool bouton_je_me_suis_trompe_autorise;
    bool edition_autorisee;
    bool filtre_actualise_en_permanace;
    QList<Question*> liste_questions_interdites;// liste qui contient les questions ne pouvant pas etre posées
    QList<Filtre> liste_filtres;

    QList<QColor> liste_couleurs;

    // Boites de dialogues
    //...vide...

    // Widgets
    QWidget *cadre_principal;

    QTableWidget *tableau_principal;

    QLabel *texte_question;
    QLabel *texte_question_permanent;
    QLabel *texte_reponse;
    QLineEdit *champ_reponse;
    QPushButton *bouton_changer;
    QPushButton *bouton_supprimer;
    QPushButton *bouton_modifier;
    QPushButton *bouton_ne_plus_voir;
    QPushButton *bouton_effacer;
    QPushButton *bouton_valider;

    QList<QDockWidget*> claviers_virtuels;

    // Boutons
    QPushButton *bouton_je_sais;
    QPushButton *bouton_je_ne_sais_pas;
    QPushButton *bouton_je_me_suis_trompe;
    QPushButton *bouton_ne_plus_voir_cette_question;
    QPushButton *bouton_sauter_cette_question;// ????

    QPushButton *bouton_ajouter_question;
    QPushButton *bouton_supprimer_question_actuelle;
    QPushButton *bouton_modifier_question_actuelle;
    QPushButton *bouton_sauter_question_actuelle;
    QPushButton *bouton_vider_liste;
    QPushButton *bouton_melanger_liste;//ouvre une boite de dialogue ou l'on peut selectionner les option pour melanger ou trier la liste
    QPushButton *bouton_melanger_liste_defaut;//mélange la liste avec les options par defaut
    QPushButton *bouton_reinitialiser_score;
    QPushButton *bouton_statistiques_bonnes_reponses;
    QPushButton *bouton_liste_des_questions;

    // Actions
    //menu fichier
    QAction *action_nouveau;
    QAction *action_ouvrir;
    QAction *action_sauvegarder;
    QAction *action_sauvegarder_sous;
    /*!!!! TODO !!!!*///Actions recements ouverts
    QAction *action_imprimer;
    QAction *action_quitter;

    //menu edition
    QAction *action_ajouter_question;
    QAction *action_supprimer_question_actuelle;
    QAction *action_supprimer_questions_selectionnees;
    QAction *action_modifier_question_actuelle;
    QAction *action_modifier_questions_selectionnees;
    QAction *action_ne_plus_voir_question_actuelle;
    QAction *action_ne_plus_voir_questions_selectionnees;
    QAction *action_inverser_reponse_derniere_question;
    QAction *action_sauter_question_actuelle;
    QAction *action_vider_liste;//supprime toutes les questions actuelles
    QAction *action_melanger_liste;//ouvre une boite de dialogue ou l'on peut selectionner les option pour melanger ou trier la liste
    QAction *action_melanger_liste_defaut;//mélange la liste avec les options par defaut
    QAction *action_filtrer_liste;
    QAction *action_inverser_filtre;
    QAction *action_reinitialiser_score;
    QAction *action_statistiques_bonnes_reponses;
    QAction *action_liste_des_questions;

    //menu preference
    QActionGroup *group_ordre;
        QAction *action_ordre_question_reponse;
        QAction *action_ordre_question_reponse_75_pour_cent;
        QAction *action_ordre_reponse_question;
        QAction *action_ordre_reponse_question_75_pour_cent;
        QAction *action_ordre_aleatoire;
    QActionGroup *group_affichage_duree;
        QAction *action_affichage_duree_jours;
        QAction *action_affichage_duree_semaine;
        QAction *action_affichage_duree_mois;
        QAction *action_affichage_duree_annee;
        QAction *action_affichage_duree_tous;
        QAction *action_affichage_duree_depuis_le;
        QAction *action_affichage_duree_personnalise;
    QAction *action_definir_tags_defaut;
    QAction *action_ajouter_supprimer_tags;
    QAction *action_supprimer_question_avec_tags;
    QAction *action_gerer_tags;
    QMenu *menu_claviers_virtuels;
        QAction *action_gerer_claviers_virtuels;
    QAction *action_calcul_automatique_difficultee;
    QAction *action_actualiser_filtre_en_permanace;
    QAction *action_ajouter_a_la_fin;
    QAction *action_tolerance;
    QAction *action_tolerance_accents;//prend en compte les accents
    QAction *action_tolerance_majuscules;
    QAction *action_preferences;

    //menu aide
    QAction *action_manuel;
    QAction *action_aide_en_ligne;
    QAction *action_rechercher_mise_a_jour;
    QAction *action_a_propos;
    QAction *action_a_propos_qt;
};

#endif
