/*
  Copyright (C) 2009 Pot Etienne

  This file is part of Vocab++.

  Vocab++ is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Vocab++ is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Vocab++.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef QUESTION_HPP
#define QUESTION_HPP

#include <QString>
#include <QStringList>
#include <QRegExp>
#include <QDateTime>

enum enum_difficulte
{
    QUESTION_DIFICULTE_TRES_FACILE = 0,
    QUESTION_DIFICULTE_FACILE = 1,
    QUESTION_DIFICULTE_MOYEN = 2,
    QUESTION_DIFICULTE_DIFFICILE = 3,
    QUESTION_DIFICULTE_TRES_DIFFICILE = 4,
};

class Question
{
public:
    Question();//constructeur par defaut

    QString question;
    QRegExp question_regexp;
    QString reponse;
    QRegExp reponse_regexp;
    QDateTime date_ajout;
    QDateTime date_derniere_fois_posee;
    int score;//nombre de fois ou l'utilisateur à répondu bon de facon conséqutive sans se tromper
    int score_recors;
    int nombre_de_fois_posee;
    int nombre_de_fois_reussi;
    char difficulte;
    QStringList tags;

    QString valeur_tris;
};

#endif
