/*
  Copyright (C) 2009 Pot Etienne

  This file is part of Vocab++.

  Vocab++ is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Vocab++ is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Vocab++.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef WIDGET_TAGS_HPP
#define WIDGET_TAGS_HPP

#include <QtGui>

class Widget_tags : public QWidget
{
    Q_OBJECT

public:
    Widget_tags(QStringList *c_liste_tags, QWidget *parent = 0);
    static QString valider_chaine(QString chaine_a_valider);

    void from_string_list(QStringList);
    QStringList to_string_list();

    QLineEdit *champ_tags;
    QHBoxLayout *layout_champ_tags;

public slots:
    void afficher_liste_tags(bool);
    void valider_champ_tags();
    void ajouter_tag(QString nouveau_tag);

private slots:
    void champ_tags_modifie();
    void vue_tag_clique(QModelIndex);
    void model_tag_change(QStandardItem*);

signals:
    void liste_tags_afficher(bool);

protected:
    QStringList *liste_tags;
    QStandardItemModel *model_liste_tags;
    bool vue_tag_clique_premier;
    bool model_tag_change_premier;
    bool champ_tags_modification_autorise;
    bool model_modification_autorise;

    QListView *vue_liste_tags;
    QPushButton *bouton_liste_tags;
};

#endif
